#!/usr/bin/python
# Version 3.1.1
# 2011-05-09 - Plan CEIBAL Uruguay
# Autor: Emiliano Pastorino - epastorino@plan.ceibal.edu.uy
# Modificado por Esteban Bordon - ebordon@plan.ceibal.edu.uy
# Modificado por Esteban Arias - earias@plan.ceibal.edu.uy
#
# Descarga e instala las actualizaciones faltantes de la XO.
# 
import commands
import os

# workaround para las XO con uy-802
#import sys
#sys.path.append("/home/local/lib")
#

from ceibal import env
from ceibal import util

ACTUALIZACIONES = "actualizaciones.list"
DIR_TEMPORAL = "/tmp/actualizaciones"
WORK_DIR = env.get_updates_root()
DIR_SEGURIDAD = env.get_security_root()
ARCH_LOG = os.path.join(WORK_DIR, "actualizador.log")
ARCH_LOG_RESP = os.path.join(WORK_DIR, "log_resp")
VERSION_ACTUAL = os.path.join(WORK_DIR, "mi_version")
#PLAZO = os.path.join(DIR_SEGURIDAD, "plazo")

ACTHOY = os.path.join(WORK_DIR, "acthoy")
PORT=5000
TIMEOUT=3
DEPS_FILE = os.path.join(DIR_TEMPORAL, "/deps.list")

def already_running():
    status,output=commands.getstatusoutput('ps -ef | grep actualizador.py | grep -v grep | wc -l')
    if not status:
        if int(output) <= 2:
            return False
        else:
            return True
    return False


def chk_env(laptop):
    '''
    Realiza el chequeo de los directorios y archivos necesarios para que funcione el programa.
    De no existir algun directorio necesario lo crea y le da permisos.
    '''
    util.clean_dir(DIR_TEMPORAL)
    if not os.path.isdir(WORK_DIR):
        os.makedirs(WORK_DIR,0744)
        #f=open(VERSION_ACTUAL,'w')
        #f.write('00000000')
        #f.close()

    if laptop in ["XO"] and not os.path.isdir(DIR_SEGURIDAD):
        os.makedirs(DIR_SEGURIDAD,0700)
        f=open(os.path.join(DIR_SEGURIDAD, "blacklisted"),'w')
        f.write('0')
        f.close()

    if not os.path.isdir(DIR_TEMPORAL):
        os.makedirs(DIR_TEMPORAL)

    if not os.path.exists(ACTHOY):
        f=open(ACTHOY,'w')
        f.write('00000000')
        f.close()
    if not os.path.exists(VERSION_ACTUAL):
        open(VERSION_ACTUAL, 'w').close()
    
    if laptop in ["XO"]:
        commands.getoutput('chown olpc:olpc %s' % env.get_ceibal_root() )
        commands.getoutput('chown olpc:olpc %s' %WORK_DIR )
    #[ebordon] Permisos de escritura para todos (acthoy) y permisos de lectura para todos (miversion)	 
    os.chmod(VERSION_ACTUAL,0666)
    os.chmod(ACTHOY,0666)

#############################################################

#############################################################
# main
#############################################################
if __name__ == "__main__":
    if already_running():
        exit()
    if os.path.exists("/ofw/"):
        chk_env("XO")
        from ceibal.actxo import ActXO
        act = ActXO()
    elif os.path.exists('/etc/ceibal-version'):
        chk_env("MG")
        from ceibal.actMG import ActMG2
        act = ActMG2()
    else:
        chk_env("JumPC")
        from ceibal.actJumPc import ActJumPc
        act = ActJumPc()
    act.run()
    
